
--Written by "ihc-433" 
--Update by "Werkstattleiter" und "Ordaton"  NAS-Moddingsquad
--Angepasst fr RTW by "Grisu118" LS2013.org
--Date: 28.12.2012

RTW_Sprinter_WAS = {};

function RTW_Sprinter_WAS.prerequisitesPresent(specializations)
    return true; 
end;

function RTW_Sprinter_WAS:load(xmlFile)
		--Erster Trigger
	self.Trigger1 = RTW_Sprinter_WAS.Trigger1;
	self.TriggerIndex1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger1#index"));
	addTrigger(self.TriggerIndex1, "Trigger1", self);
	self.enteredTrigger1 = false;
		--Zweiter Trigger
	self.Trigger2 = RTW_Sprinter_WAS.Trigger2;
	self.TriggerIndex2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger2#index"));
	addTrigger(self.TriggerIndex2, "Trigger2", self);
	self.enteredTrigger2 = false;
		--dritter Trigger
	self.Trigger3 = RTW_Sprinter_WAS.Trigger3;
	self.TriggerIndex3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger3#index"));
	addTrigger(self.TriggerIndex3, "Trigger3", self);
	self.enteredTrigger3 = false;
		--Vierter Trigger
	self.Trigger4 = RTW_Sprinter_WAS.Trigger4;
	self.TriggerIndex4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger4#index"));
	addTrigger(self.TriggerIndex4, "Trigger4", self);
	self.enteredTrigger4 = false;
		--Fnfter Trigger
	self.Trigger5 = RTW_Sprinter_WAS.Trigger5;
	self.TriggerIndex5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger5#index"));
	addTrigger(self.TriggerIndex5, "Trigger5", self);
	self.enteredTrigger5 = false;
	
	local hydraulicsCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.hydraulics#count"), 0);	
	self.hydraulics = {};	
	for i=1, hydraulicsCount do
		local hydraulicName = string.format("vehicle.hydraulics.hydraulic%d", i);		
		self.hydraulics[i] = {};		
		self.hydraulics[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#index"));
		self.hydraulics[i].punch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punch"));
		self.hydraulics[i].translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punchFixpoint"));
		self.hydraulics[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#fixpoint"));
		if self.hydraulics[i].punch ~= nil and self.hydraulics[i].translationPunch ~= nil then
			local ax, ay, az = getWorldTranslation(self.hydraulics[i].punch);
			local bx, by, bz = getWorldTranslation(self.hydraulics[i].translationPunch);		
			self.hydraulics[i].punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		end;
	end;
	
end;

function RTW_Sprinter_WAS:Trigger1(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger1 = true;
		end;
	if onLeave then 
		self.enteredTrigger1 = false;
		end;
	end;
end;
function RTW_Sprinter_WAS:Trigger2(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger2 = true;
		end;
	if onLeave then 
		self.enteredTrigger2 = false;
		end;
	end;
end;
function RTW_Sprinter_WAS:Trigger3(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger3 = true;
		end;
	if onLeave then 
		self.enteredTrigger3 = false;
		end;
	end;
end;
function RTW_Sprinter_WAS:Trigger4(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger4 = true;
		end;
	if onLeave then 
		self.enteredTrigger4 = false;
		end;
	end;
end;
function RTW_Sprinter_WAS:Trigger5(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger5 = true;
		end;
	if onLeave then 
		self.enteredTrigger5 = false;
		end;
	end;
end;

function RTW_Sprinter_WAS:readStream(streamId, connection)
	
end;

function RTW_Sprinter_WAS:writeStream(streamId, connection)	
	
end;

function RTW_Sprinter_WAS:delete()
	
end;

function RTW_Sprinter_WAS:mouseEvent(posX, posY, isDown, isUp, button)
end;

function RTW_Sprinter_WAS:keyEvent(unicode, sym, modifier, isDown)
end;

function RTW_Sprinter_WAS:update(dt)
	if self.enteredTrigger1 then 
		if InputBinding.isPressed(InputBinding.RTW_Tuer_1) then 
			self:setAnimationTime(1, self.animationParts[1].currentPosition+(self.animationParts[1].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.RTW_Tuer_2) then 
			self:setAnimationTime(1, self.animationParts[1].currentPosition-(self.animationParts[1].offSet*(dt/5)));
		end;		
		if self.animationParts[1].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RTW_Tuer_1")), InputBinding.RTW_Tuer_1);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RTW_Tuer_2")), InputBinding.RTW_Tuer_2);
		end;		
	end;
	if self.enteredTrigger2 then
		if InputBinding.isPressed(InputBinding.RTW_Tuer_3) then 
			self:setAnimationTime(2, self.animationParts[2].currentPosition+(self.animationParts[2].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.RTW_Tuer_4) then 
			self:setAnimationTime(2, self.animationParts[2].currentPosition-(self.animationParts[2].offSet*(dt/5)));
		end;
		if self.animationParts[2].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RTW_Tuer_3")), InputBinding.RTW_Tuer_3);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RTW_Tuer_4")), InputBinding.RTW_Tuer_4);
		end;		
	end;
	if self.enteredTrigger3 then
		if InputBinding.isPressed(InputBinding.RTW_Tuer_3) then 
			self:setAnimationTime(3, self.animationParts[3].currentPosition+(self.animationParts[3].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.RTW_Tuer_4) then 
			self:setAnimationTime(3, self.animationParts[3].currentPosition-(self.animationParts[3].offSet*(dt/5)));
		end;
		if self.animationParts[3].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RTW_Tuer_5")), InputBinding.RTW_Tuer_3);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RTW_Tuer_6")), InputBinding.RTW_Tuer_4);
		end;		
	end;
	if self.enteredTrigger4 then
		if InputBinding.isPressed(InputBinding.RTW_Tuer_3) then 
			self:setAnimationTime(4, self.animationParts[4].currentPosition+(self.animationParts[4].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.RTW_Tuer_4) then 
			self:setAnimationTime(4, self.animationParts[4].currentPosition-(self.animationParts[4].offSet*(dt/5)));
		end;
		if self.animationParts[4].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RTW_Tuer_7")), InputBinding.RTW_Tuer_3);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RTW_Tuer_8")), InputBinding.RTW_Tuer_4);
		end;		
	end;
	if self.enteredTrigger5 then
		if InputBinding.isPressed(InputBinding.RTW_Tuer_3) then 
			self:setAnimationTime(5, self.animationParts[5].currentPosition+(self.animationParts[5].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.RTW_Tuer_4) then 
			self:setAnimationTime(5, self.animationParts[5].currentPosition-(self.animationParts[5].offSet*(dt/5)));
		end;
		if self.animationParts[5].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RTW_Tuer_5")), InputBinding.RTW_Tuer_3);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RTW_Tuer_6")), InputBinding.RTW_Tuer_4);
		end;		
	end;

	
	
end;

function RTW_Sprinter_WAS:triggerCallback(triggerId,otherId,onEnter,onLeave,onStay)
    if (triggerId == self.stateChange) then
        if (onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode) then
            self.changeAllowed = true;
        elseif (onLeave) then
            self.changeAllowed = false;
        end;
    end;
end;

function RTW_Sprinter_WAS:updateTick(dt)

	for i=1, table.getn(self.hydraulics) do
		local ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
		local bx, by, bz = getWorldTranslation(self.hydraulics[i].fixPoint);
		if bx ~= nil and by ~= nil and bz ~= nil then
			local x, y, z = worldDirectionToLocal(getParent(self.hydraulics[i].node), bx-ax, by-ay, bz-az);
			setDirection(self.hydraulics[i].node, x, y, z, 0, 0, 1);
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			if self.hydraulics[i].punch ~= nil and self.hydraulics[i].punchDistance ~= nil and self.hydraulics[i].translationPunch then
				if self.hydraulics[i].doScale then
					local xScale, yScale, zScale = getScale(self.hydraulics[i].punch);
					local newScale = xScale * (distance / self.hydraulics[i].punchDistance);
					setScale(self.hydraulics[i].punch, 1, 1, newScale);
				else
					setTranslation(self.hydraulics[i].punch, 0, 0, distance-self.hydraulics[i].punchDistance);
				end;
			end;
		end;
	end;
	
end;

function RTW_Sprinter_WAS:draw()
	


end;

function RTW_Sprinter_WAS:onLeave()
	
end;